drop table measurements if exists;
drop table radacct if exists;
drop table subnets if exists;
drop table users if exists;
create table measurements (measurement_id bigint generated by default as identity (start with 1), calledstationid varchar(255), callingstationid varchar(255), client_ip varchar(255), measurement_date timestamp, measurement_download_rate double, framedipaddress varchar(255), latitude double, measurement_local_ping double, location_method varchar(255), longitude double, nasipaddress varchar(255), nasportid varchar(255), nasporttype varchar(255), acctsessionid varchar(255), acctstarttime timestamp, measurement_upload_rate double, user_agent varchar(255), username varchar(255), primary key (measurement_id));
create table radacct (radacctid bigint not null, acctauthentic varchar(255), calledstationid varchar(255), callingstationid varchar(255), connectinfo_start varchar(255), connectinfo_stop varchar(255), framedipaddress varchar(255), framedprotocol varchar(255), groupname varchar(255), acctinputoctets numeric(19,2), nasipaddress varchar(255), nasportid varchar(255), nasporttype varchar(255), acctoutputoctets numeric(19,2), realm varchar(255), servicetype varchar(255), acctsessionid varchar(255), acctsessiontime bigint, acctstartdelay bigint, acctstarttime timestamp, acctstopdelay bigint, acctstoptime timestamp, acctterminatecause varchar(255), acctuniqueid varchar(255), username varchar(255), xascendsessionsvrkey varchar(255), primary key (radacctid));
create table subnets (subnet_id bigint generated by default as identity (start with 1), subnet varchar(255), primary key (subnet_id));
create table users (id bigint generated by default as identity (start with 1), email varchar(255) not null, password_hash varchar(255) not null, role varchar(255) not null, primary key (id));
alter table subnets add constraint UK_hy8sqpufpj8hbqs0smltxq4kr unique (subnet);
alter table users add constraint UK_6dotkott2kjsp8vw4d0m25fb7 unique (email);

insert into users(email, password_hash, role) VALUES ('test@test.test', '$2a$04$8DvKRtewuckoneTQcdiFd.0vmGw.eGLBMwamqhNydJiDZFJ4ZxfUG', 'USER');
insert into users(email, password_hash, role) VALUES ('admin@test.test', '$2a$04$8DvKRtewuckoneTQcdiFd.0vmGw.eGLBMwamqhNydJiDZFJ4ZxfUG', 'ADMIN');